diff --git a/web/app/javascript/controllers/daemon_health_controller.js b/web/app/javascript/controllers/daemon_health_controller.js
new file mode 100644
index 0000000..ac9eec8
--- /dev/null
+++ b/web/app/javascript/controllers/daemon_health_controller.js
@@ -0,0 +1,122 @@
+import { Controller } from "@hotwired/stimulus"
+
+// Daemon health banner (U7). Fetches /daemon/status once on connect; a
+// healthy daemon keeps the banner hidden. While UNHEALTHY (down or binary
+// drift) the banner shows the diagnosis and polls at a low frequency so it
+// clears itself shortly after a repair — without adding steady-state
+// request load to the box.
+//
+// The repair button is confirm-gated (the browser dialog is the confirm UX;
+// Stimulus requires [data-confirm] handling here because plain Turbo form
+// confirmation doesn't cover button-initiated fetches).
+export default class extends Controller {
+  static targets = ["banner", "message", "output", "repair"]
+  static values = {
+    statusUrl: String,
+    repairUrl: String,
+    unhealthyPollMs: { type: Number, default: 10000 },
+    repairPollMs: { type: Number, default: 2000 }
+  }
+
+  connect() {
+    this.refresh()
+  }
+
+  disconnect() {
+    this.stopPolling()
+  }
+
+  async repair(event) {
+    if (event && !window.confirm(event.target.getAttribute("data-confirm"))) return
+    if (this.repairing) return
+
+    this.repairing = true
+    this.repairTarget.disabled = true
+    this.repairTarget.textContent = "Repairing…"
+
+    try {
+      const response = await fetch(this.repairUrlValue, {
+        method: "POST",
+        headers: {
+          "X-CSRF-Token": document.querySelector('meta[name="csrf-token"]').content,
+          "Accept": "application/json"
+        },
+        body: ""
+      })
+      const payload = await response.json()
+      this.renderOutput(payload)
+
+      // Poll fast for a while so the banner clears as soon as the daemon
+      // is back, then fall back to the unhealthy cadence.
+      this.startPolling(this.repairPollMsValue, 12)
+    } catch {
+      this.messageTarget.textContent = "Repair request failed — is the web server reachable?"
+      this.bannerTarget.hidden = false
+    } finally {
+      this.repairing = false
+      this.repairTarget.disabled = false
+      this.repairTarget.textContent = "Repair daemon"
+    }
+  }
+
+  async refresh() {
+    try {
+      const response = await fetch(this.statusUrlValue, { headers: { "Accept": "application/json" } })
+      if (!response.ok) return
+      const payload = await response.json()
+      this.render(payload.daemon)
+    } catch {
+      // A transient network hiccup should not nag the operator.
+    }
+  }
+
+  render(daemon) {
+    const healthy = daemon.running && daemon.drift_kind === "none"
+    if (healthy) {
+      this.bannerTarget.hidden = true
+      this.outputTarget.hidden = true
+      this.stopPolling()
+      return
+    }
+
+    this.messageTarget.textContent = daemon.drift_kind === "unit_path"
+      ? `Daemon binary drifted: the installed unit runs ${daemon.unit_bin_path} but hive resolves to ${daemon.cli_bin_path}.`
+      : daemon.drift_kind === "live_binary"
+        ? `Daemon binary drifted: the running daemon (pid ${daemon.pid}) executes ${daemon.live_bin_path} but hive resolves to ${daemon.cli_bin_path}.`
+        : "The daemon is not running — tasks will not advance until it starts."
+    this.bannerTarget.hidden = false
+    if (!this.timer) this.startPolling(this.unhealthyPollMsValue)
+  }
+
+  renderOutput(payload) {
+    if (payload.output && payload.output.trim()) {
+      this.outputTarget.textContent = payload.output.trim()
+      this.outputTarget.hidden = false
+    }
+    if (payload.ok === false) {
+      this.messageTarget.textContent = payload.message || "The repair did not complete."
+    }
+  }
+
+  startPolling(intervalMs, maxTicks = null) {
+    this.stopPolling()
+    this.ticks = 0
+    this.maxTicks = maxTicks
+    this.timer = setInterval(() => {
+      this.ticks += 1
+      this.refresh()
+      if (this.maxTicks && this.ticks >= this.maxTicks) {
+        this.stopPolling()
+        // Done with the fast repair window: drop to the unhealthy cadence.
+        if (!this.bannerTarget.hidden) this.startPolling(this.unhealthyPollMsValue)
+      }
+    }, intervalMs)
+  }
+
+  stopPolling() {
+    if (this.timer) {
+      clearInterval(this.timer)
+      this.timer = null
+    }
+  }
+}
diff --git a/web/app/views/status/_daemon_health.html.erb b/web/app/views/status/_daemon_health.html.erb
new file mode 100644
index 0000000..4e5a738
--- /dev/null
+++ b/web/app/views/status/_daemon_health.html.erb
@@ -0,0 +1,16 @@
+<%# Daemon health banner (U7). Rendered empty server-side; the
+    daemon-health Stimulus controller fetches /daemon/status once on
+    connect and re-polls at a low frequency ONLY while unhealthy. A
+    healthy daemon renders no banner at all — the grid stays quiet. %>
+<div class="daemon-banner" data-controller="daemon-health" data-daemon-health-status-url-value="<%= daemon_status_path %>" data-daemon-health-repair-url-value="<%= daemon_repair_path %>">
+  <div data-daemon-health-target="banner" hidden>
+    <p data-daemon-health-target="message" class="daemon-banner-message"></p>
+    <pre data-daemon-health-target="output" class="daemon-banner-output" hidden></pre>
+    <button type="button" class="btn btn-sm daemon-banner-repair"
+            data-daemon-health-target="repair"
+            data-action="daemon-health#repair"
+            data-confirm="Repair the daemon now? This restarts the hive-daemon service.">
+      Repair daemon
+    </button>
+  </div>
+</div>
diff --git a/web/app/views/status/index.html.erb b/web/app/views/status/index.html.erb
index 25bcdf7..364ff7d 100644
--- a/web/app/views/status/index.html.erb
+++ b/web/app/views/status/index.html.erb
@@ -26,6 +26,8 @@
   </aside>
   <div class="status-main">
 
+<%= render "status/daemon_health" %>
+
 <%# data-turbo-permanent: a morph must never touch the composer — it holds
     typed-but-unsent idea text and staged image attachments (Stimulus state
     the server can't re-render). %>
diff --git a/web/config/routes.rb b/web/config/routes.rb
index 659576d..9faaf8b 100644
--- a/web/config/routes.rb
+++ b/web/config/routes.rb
@@ -19,6 +19,11 @@ Rails.application.routes.draw do
 
   post "ideas" => "ideas#create", as: :ideas
 
+  # Daemon health surface (U7): JSON status for the dashboard banner and
+  # the confirm-gated repair action. Both inherit the standard auth gate.
+  get  "daemon/status" => "daemon#status", as: :daemon_status
+  post "daemon/repair" => "daemon#repair", as: :daemon_repair
+
   # Task pages are addressed by project name + task slug, mirroring the CLI.
   scope "tasks/:project/:slug", constraints: { slug: /[a-z][a-z0-9-]{0,62}[a-z0-9]/, project: %r{[^/]+} } do
     get  "" => "tasks#show", as: :task
diff --git a/web/test/integration/daemon_health_test.rb b/web/test/integration/daemon_health_test.rb
new file mode 100644
index 0000000..6fc11e8
--- /dev/null
+++ b/web/test/integration/daemon_health_test.rb
@@ -0,0 +1,158 @@
+require "test_helper"
+require "hive/daemon/consistency_probe"
+
+# U7: the daemon-health surface. /daemon/status is a JSON read computed
+# in-process (pidfile probe + consistency probe, no subprocess);
+# /daemon/repair is the single write action running a bounded subprocess.
+# Both inherit the standard auth gate.
+class DaemonHealthTest < ActionDispatch::IntegrationTest
+  setup do
+    @orig_noauth = ENV["HIVEBOX_LOCAL_NOAUTH"]
+    ENV["HIVEBOX_LOCAL_NOAUTH"] = "1"
+    @orig_invoked = ENV["HIVE_INVOKED_BIN"]
+  end
+
+  teardown do
+    if @orig_noauth.nil?
+      ENV.delete("HIVEBOX_LOCAL_NOAUTH")
+    else
+      ENV["HIVEBOX_LOCAL_NOAUTH"] = @orig_noauth
+    end
+    if @orig_invoked.nil?
+      ENV.delete("HIVE_INVOKED_BIN")
+    else
+      ENV["HIVE_INVOKED_BIN"] = @orig_invoked
+    end
+  end
+
+  test "status reports a down daemon without drift" do
+    get daemon_status_path
+    assert_response :success
+    payload = JSON.parse(response.body)
+    assert payload.fetch("ok")
+    daemon = payload.fetch("daemon")
+    assert_equal false, daemon.fetch("running")
+    assert_equal "none", daemon.fetch("drift_kind")
+  end
+
+  test "status is refused for non-loopback requests in no-auth mode" do
+    get daemon_status_path, env: { "REMOTE_ADDR" => "203.0.113.9" }
+    assert_response :redirect
+  end
+
+  test "repair starts a stopped daemon via a bounded subprocess" do
+    # No live daemon → the controller must pick `daemon start --detach`.
+    stubbed = Object.new
+    stubbed.define_singleton_method(:call) do
+      Hive::Daemon::ConsistencyProbe::Result.new(
+        running: false, pid: nil, cli_bin_path: "/bin/hive", unit_bin_path: nil,
+        live_bin_path: nil, live_version_matches: nil, drift_kind: "none"
+      )
+    end
+
+    captured_argv = nil
+    controller_stub = lambda { |argv|
+      captured_argv = argv
+      [ "fake output\n", false ]
+    }
+
+    ENV["HIVE_INVOKED_BIN"] = "/bin/hive"
+    with_stubbed_probe(stubbed) do
+      with_stubbed_subprocess(controller_stub) do
+        post daemon_repair_path
+        assert_response :success
+        payload = JSON.parse(response.body)
+        assert payload.fetch("ok")
+        assert_equal %w[daemon start --detach], payload.fetch("action")
+        assert_equal "fake output", payload.fetch("output").strip
+      end
+    end
+    assert_equal [ "/bin/hive", "daemon", "start", "--detach" ], captured_argv
+  end
+
+  test "repair force-reinstalls a drifted daemon" do
+    stubbed = Object.new
+    stubbed.define_singleton_method(:call) do
+      Hive::Daemon::ConsistencyProbe::Result.new(
+        running: true, pid: 4242, cli_bin_path: "/bin/hive", unit_bin_path: "/usr/bin/hive",
+        live_bin_path: "/usr/bin/hive", live_version_matches: false, drift_kind: "unit_path"
+      )
+    end
+
+    captured_argv = nil
+    controller_stub = lambda { |argv|
+      captured_argv = argv
+      [ "upgraded\n", false ]
+    }
+
+    ENV["HIVE_INVOKED_BIN"] = "/bin/hive"
+    with_stubbed_probe(stubbed) do
+      with_stubbed_subprocess(controller_stub) do
+        post daemon_repair_path
+        assert_response :success
+        payload = JSON.parse(response.body)
+        assert_equal %w[daemon install --force], payload.fetch("action")
+      end
+    end
+    assert_equal [ "/bin/hive", "daemon", "install", "--force" ], captured_argv
+  end
+
+  test "repair timeout renders a typed partial-failure" do
+    stubbed = Object.new
+    stubbed.define_singleton_method(:call) do
+      Hive::Daemon::ConsistencyProbe::Result.new(
+        running: false, pid: nil, cli_bin_path: "/bin/hive", unit_bin_path: nil,
+        live_bin_path: nil, live_version_matches: nil, drift_kind: "none"
+      )
+    end
+
+    with_stubbed_probe(stubbed) do
+      # Force the controller's subprocess to time out by making spawn block
+      # past the deadline — here we stub bounded_subprocess itself to raise
+      # the typed error the timeout path produces, and pin the message text
+      # (the controller maps it to a 503 JSON payload).
+      DaemonController.define_singleton_method(:new) do |*_args|
+        controller = super(*_args)
+        controller.define_singleton_method(:bounded_subprocess) do |_argv|
+          raise DaemonController::RepairFailed,
+                "the repair command timed out after 120s and was killed. " \
+                "The daemon may still be draining (TimeoutStopSec=900); " \
+                "check `hive daemon status` and re-run repair."
+        end
+        controller
+      end
+      begin
+        post daemon_repair_path
+        assert_response :service_unavailable
+        payload = JSON.parse(response.body)
+        assert_equal false, payload.fetch("ok")
+        assert_match(/timed out/, payload.fetch("message"))
+        assert_match(/re-run repair/, payload.fetch("message"))
+      ensure
+        DaemonController.singleton_class.send(:remove_method, :new)
+      end
+    end
+  end
+
+  private
+
+  def with_stubbed_probe(stubbed)
+    original = Hive::Daemon::ConsistencyProbe.method(:new)
+    Hive::Daemon::ConsistencyProbe.define_singleton_method(:new) { |**_kw| stubbed }
+    begin
+      yield
+    ensure
+      Hive::Daemon::ConsistencyProbe.define_singleton_method(:new, original)
+    end
+  end
+
+  def with_stubbed_subprocess(runner)
+    original = DaemonController.instance_method(:bounded_subprocess)
+    DaemonController.define_method(:bounded_subprocess) { |argv| runner.call(argv) }
+    begin
+      yield
+    ensure
+    DaemonController.define_method(:bounded_subprocess, original)
+    end
+  end
+end
diff --git a/web/test/integration/local_noauth_test.rb b/web/test/integration/local_noauth_test.rb
new file mode 100644
index 0000000..9b14d48
--- /dev/null
+++ b/web/test/integration/local_noauth_test.rb
@@ -0,0 +1,45 @@
+require "test_helper"
+
+# U1: local no-auth mode. `hive web` exports HIVEBOX_LOCAL_NOAUTH=1 when the
+# resolved auth mode is "none" (loopback bind, no claimed owner). The UI must
+# then serve authenticated pages to requests FROM a loopback address without
+# any session — and must still refuse non-loopback remote IPs (defense in
+# depth). Without the env, the existing login redirect is unchanged.
+class LocalNoauthTest < ActionDispatch::IntegrationTest
+  setup do
+    @orig = ENV["HIVEBOX_LOCAL_NOAUTH"]
+    ENV["HIVEBOX_LOCAL_NOAUTH"] = "1"
+  end
+
+  teardown do
+    if @orig.nil?
+      ENV.delete("HIVEBOX_LOCAL_NOAUTH")
+    else
+      ENV["HIVEBOX_LOCAL_NOAUTH"] = @orig
+    end
+  end
+
+  test "loopback request is served without a session" do
+    # Integration tests default to 127.0.0.1 remote_addr.
+    get root_path
+    assert_response :success
+    assert_nil session[:github_login], "the tokenless session must not fabricate an identity"
+  end
+
+  test "non-loopback remote ip is still refused under the env" do
+    # Spoof a non-loopback client address (reverse proxy or LAN attacker).
+    get root_path, env: { "REMOTE_ADDR" => "203.0.113.9" }
+    assert_redirected_to "/login"
+  end
+
+  test "ipv6 loopback is served" do
+    get root_path, env: { "REMOTE_ADDR" => "::1" }
+    assert_response :success
+  end
+
+  test "without the env the login redirect is unchanged" do
+    ENV.delete("HIVEBOX_LOCAL_NOAUTH")
+    get root_path
+    assert_redirected_to "/login"
+  end
+end
diff --git a/web/test/system/daemon_health_test.rb b/web/test/system/daemon_health_test.rb
new file mode 100644
index 0000000..3e6884b
--- /dev/null
+++ b/web/test/system/daemon_health_test.rb
@@ -0,0 +1,31 @@
+require "application_system_test_case"
+
+# U7 system test: the dashboard daemon-health banner. The sandbox daemon is
+# not running, so /daemon/status reports running:false — the banner must
+# appear within the first status fetch and offer the confirm-gated repair.
+# (A healthy daemon renders no banner at all; that state is pinned by the
+# controller-level JS contract, not by a browser run.)
+class DaemonHealthSystemTest < ApplicationSystemTestCase
+  setup do
+    @project = create_hive_project!
+    configure_owner!
+    sign_in!
+  end
+
+  test "down daemon shows the health banner on the dashboard" do
+    visit root_path
+    message = find(".daemon-banner-message", wait: 5)
+    assert_match(/daemon is not running/, message.text)
+  end
+
+  test "banner offers a confirm-gated repair button" do
+    visit root_path
+    button = find(".daemon-banner-repair", wait: 5)
+    assert_equal "Repair daemon", button.text
+    # Dismissing the confirm leaves the banner untouched (no repair fetch).
+    page.driver.dismiss_confirm do
+      button.click
+    end
+    assert button.visible?
+  end
+end
